/*
  Ultrasonic Party Starter for Arduino
  
  Ever wanted the party to start as soon as you walked in the room?
  This project uses the hc-sr04 ping sensor to flash an RGB LED to
  the beat of "Aerodynamic" by Daft Punk when an object comes
  within a proximity range.
  
  created 18 May 2015
  by Jeremy Cruz
  featuring music by Daft Punk
  
*/
#include "pitches.h" //Be sure that pitches.h is in the same directory 

const byte noteLength = 125;
const byte speakerPin = 8;
const byte RED_PIN = 9;
const byte GREEN_PIN = 10;
const byte BLUE_PIN = 11;
const byte trigPin = 7;
const byte echoPin = 13;

void setup() {
  Serial.begin (9600);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(speakerPin, OUTPUT);
  pinMode(RED_PIN, OUTPUT);
  pinMode(GREEN_PIN, OUTPUT);
  pinMode(BLUE_PIN, OUTPUT);

}

//Plays the keyboard solo to Daft Punk's "Aerodynamic" while flashing LED
void aerodynamicMelody(){
  for(byte i = 0; i <= 1; i++){
    for(byte i = 0; i <= 3; i++){
      tone(speakerPin, NOTE_D5, noteLength);
      //Flash red
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
      
      tone(speakerPin, NOTE_FS4, noteLength);
      //Flash cyan
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_B5, noteLength);
      //Flash yellow
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
      
      tone(speakerPin, NOTE_FS4, noteLength);
      //Flash purple
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
    }
    for(byte i = 0; i <= 3; i++){
      tone(speakerPin, NOTE_D5, noteLength);
      //Flash blue
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_GS4, noteLength);
      //Flash purple
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_B5, noteLength);
      //Flash white
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_GS4, noteLength);
      //Flash green
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
    }  
    for(byte i = 0; i <= 3; i++){
      tone(speakerPin, NOTE_G6, noteLength);
      //Flash cyan
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_E6, noteLength);
      //Flash red
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
      
      tone(speakerPin, NOTE_B6, noteLength);
      //Flash green
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
      
      tone(speakerPin, NOTE_E6, noteLength);
      //Flash blue
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
    }
    for(byte i = 0; i <= 3; i++){
      tone(speakerPin, NOTE_E5, noteLength);
      //Flash yellow
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
      
      tone(speakerPin, NOTE_A6, noteLength);
      //Flash white
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, HIGH);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_CS6, noteLength);
      //Flash blue
      digitalWrite(RED_PIN, LOW);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, HIGH);
      delay(noteLength);
      
      tone(speakerPin, NOTE_A6, noteLength);
      //Flash red
      digitalWrite(RED_PIN, HIGH);
      digitalWrite(GREEN_PIN, LOW);
      digitalWrite(BLUE_PIN, LOW);
      delay(noteLength);
      digitalWrite(RED_PIN, LOW);
    }
  }  
}
void loop(){
   long duration, distance;
   digitalWrite(trigPin, LOW);
   delayMicroseconds(2);
   digitalWrite(trigPin, HIGH);
   delayMicroseconds(5);
   digitalWrite(trigPin, LOW);
   duration = pulseIn(echoPin, HIGH);
   distance = (duration/2) / 29; //gives you the distance in cm
   if (distance <= 100){
     aerodynamicMelody();
   }
   delay(100);
}

